#include <iostream.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <graphics.h>
//----------------------------------------------------
class Polozenie
{
  protected:
    int wsp_X, wsp_Y;
  public:
    Polozenie(int x, int y) : wsp_X(x), wsp_Y(y)
     { };
    int Jakie_X() { return wsp_X;}
    int Jakie_Y() { return wsp_Y;}
};
class Punkt :  public Polozenie
{
  protected:
    int  kolor;
    int Przesuwaj(int &del_X, int &del_Y);
  public:
    Punkt(int x, int y, int kol);
    ~Punkt();
    virtual void Pokaz();
    virtual void Ukryj();
    virtual void Przesun(int x, int y);
    virtual void Ruch(int skok);
};
//----------------------------------------------------
class Okrag : public Punkt
{
  int Promien;
  public:
    Okrag(int x, int y, int kol, int R);
    ~Okrag();
    virtual void Pokaz();
    virtual void Ukryj();
    virtual void Przesun(int x, int y);
    virtual void Ruch(int skok);
};
//----------------------------------------------------

int Sterownik, Tryb;
void Inicjalizacja_Grafiki();
//----------------------------------------------------
void main()
{
  Punkt Pierwszy(300, 200, LIGHTRED);
  Okrag Drugi(300, 250, GREEN, 50);
  Inicjalizacja_Grafiki();
  Pierwszy.Pokaz();
  getch();
  Pierwszy.Ruch(20);
  Drugi.Pokaz();
  getch();
  Drugi.Ukryj();
  getch();
  Drugi.Pokaz();
  getch();
  Drugi.Przesun(100, 150);
  getch();
  Drugi.Ruch(5);
  getch();
  Pierwszy.Punkt::~Punkt();
  getch();
  Drugi.Okrag::~Okrag();
  getch();
  closegraph();
}
//---------------------------------------------------


int Punkt::Przesuwaj(int &del_X, int &del_Y)
{
  const int ESC = 27,
	   GORA = 72,
	    DOL = 80,
	   LEWO = 75,
	  PRAWO = 77;
  int Przycisk, Koniec = 1;
    del_X = 0;
    del_Y = 0;
    Przycisk = getch();
    switch (Przycisk)
      {
	case  GORA : { del_Y = -1; break; }
	case   DOL : { del_Y = 1; break; }
	case  LEWO : { del_X = -1; break; }
	case PRAWO : { del_X = 1; break; }
	case   ESC : { Koniec = 0; break; }
	   default : {  break; }
       }
   return Koniec;
}
Punkt::Punkt(int x, int y, int kol) : Polozenie(x,y), kolor(kol)
 { }
//-------------------------------------------------
Punkt::~Punkt()
 {
   Ukryj();
 }
//-------------------------------------------------
void Punkt::Pokaz()
 {
   putpixel(wsp_X, wsp_Y, kolor);
 }
//------------------------------------------------
void Punkt::Ukryj()
 { int tlo = 0;
   putpixel(wsp_X, wsp_Y, tlo);
 }
//------------------------------------------------
void Punkt::Przesun(int x, int y)
{
  Ukryj();
  wsp_X = x;
  wsp_Y = y;
  Pokaz();
}
//------------------------------------------------
void Punkt::Ruch(int skok)
{
  int del_X, del_Y, fig_X, fig_Y;
  Pokaz();
  fig_X = Jakie_X();
  fig_Y = Jakie_Y();
  while (Przesuwaj(del_X, del_Y))
  {
    fig_X = fig_X + del_X*skok;
    fig_Y = fig_Y + del_Y*skok;
    Przesun(fig_X, fig_Y);
  }
}
//------------------------------------------------
Okrag::Okrag(int x, int y, int kol, int R) : Punkt(x,y,kol)
{
  Promien = R;
  kolor = kol;
}
//------------------------------------------------
Okrag::~Okrag()
{
  Ukryj();
}
//------------------------------------------------
void Okrag::Pokaz()
{
  setcolor(kolor);
  circle(wsp_X, wsp_Y, Promien);
}
//------------------------------------------------
void Okrag::Ukryj()
{
  int tlo = 0, tmp_kolor = kolor;
  kolor = tlo;
  setcolor(kolor);
  circle(wsp_X, wsp_Y, Promien);
  kolor = tmp_kolor;
}
//------------------------------------------------
void Okrag::Przesun(int x, int y)
{
  Ukryj();
  wsp_X = x;
  wsp_Y = y;
  Pokaz();
}
//------------------------------------------------
void Okrag::Ruch(int skok)
{
  int del_X, del_Y, fig_X, fig_Y;
  Pokaz();
  fig_X = Jakie_X();
  fig_Y = Jakie_Y();
  while (Przesuwaj(del_X, del_Y))
  {
    fig_X = fig_X + del_X*skok;
    fig_Y = fig_Y + del_Y*skok;
    Przesun(fig_X, fig_Y);
  }
}
void Inicjalizacja_Grafiki()
{
  Sterownik = DETECT;
  initgraph(&Sterownik, &Tryb, "");
}
//-------------------------------------------------